## Námi dodané styly

*   LLVM ([http://llvm.org/docs/CodingStandards.html](http://llvm.org/docs/CodingStandards.html))
*   Google ([https://google.github.io/styleguide/cppguide.html](https://google.github.io/styleguide/cppguide.html))
*   Chromium ([http://www.chromium.org/developers/coding-style](http://www.chromium.org/developers/coding-style))
*   Mozilla ([https://developer.mozilla.org/en-US/docs/Developer_Guide/Coding_Style](https://developer.mozilla.org/en-US/docs/Developer_Guide/Coding_Style))
*   WebKit ([http://www.webkit.org/coding/coding-style.html](http://www.webkit.org/coding/coding-style.html))
*   Mesos (Apache Mesos [http://www.webkit.org/coding/coding-style.html](http://mesos.apache.org/documentation/latest/c++-style-guide))
*   PB161 (výchozí styl, viz níže)

### Styl PB161

Tento styl je odvozen od stylu WebKit, avšak s následujícími změnami:

*   Otevírací závorka těla funkce je na stejném řádku, jako hlavička funkce.
*   Krátké bloky kódu a těla funkcí je možné držet v jednom řádku.
*   Inicializační sekce konstruktoru může být na stejném řádku jako hlavička konstruktoru.
*   Mezery kolem * u ukazatelů a & u referencí se sjednotí podle verze, která je v souboru nejpoužívanější. A pokud by bylo skóre vyrovnané, tak se pro jistotu dá mezera doleva i doprava.
*   Vizuální zarovnání pravých stran po sobě jdoucích řádků s přiřazením je povoleno.

```c++
    int velmiDlouhaDemonstracniPromenna = 5;
    int jinaDemonstracniPromenna        = 42;
```

## Kde získat styly?

Konfigurační soubory jednotlivých stylů najdete v [tomto repozitáři](https://gitlab.fi.muni.cz/xrucka/styly). Zde budeme publikovat Vaše styly, které jsme schválili. Současně zde bude i odpovídající demonstrační příklad, na kterém můžete vidět, jak vypadají nejčastější kousky kódu, formátované konkrétním stylem.

## Jak styl použiji?

Zvolený styl deklarujete (pro automatické odevzdání) souborem codestyle.txt. Do tohoto souboru umístěte jediný řádek, sice jméno stylu (tj. např. WebKit). Pro aplikaci tohoto stylu na svůj kód pak soubor se stylem (např. WebKit.yml) zkopírujte do adresáře s projektem a přejmenujte na _clang-format (popř. .clang-format). Pak už postupujte podle návodu pro clang-format s konfiguračním souborem (volba -style=file).

## Jak přihlásím vlastní styl?

Naklonujte či forkněte si repozitář se styly a pošlete nám buď merge request (pro uživatele znalé GitHubu pull request), či patch emailem (pb161 zavináč fi.muni.cz). Pokud budeme považovat styl za přípustný, Váš commit do repozitáře zařadíme.
